<div fxLayout="column">
    <table mat-table [dataSource]="uiDatas" class="edition-table"
           [attr.aria-describedby]="'BOOK.EDITION.TABLE.HEADERS.DESCRIBED_BY' | translate">

        <ng-container matColumnDef="seriesEditor">
            <th mat-header-cell *matHeaderCellDef
                scope="col"> {{'BOOK.EDITION.TABLE.HEADERS.EDITOR_SERIES' | translate}}</th>
            <td mat-cell *matCellDef="let element; let index = index" [formGroup]="uiDatas[index].form">
                {{ uiDatas[index].item.editor.name }} -
                <span *ngIf="!uiDatas[index].item.series.oneShot else oneShotDisplay">
           {{ uiDatas[index].item.series.name }}
        </span>
                <ng-template #oneShotDisplay>
          <span>
            {{ uiDatas[index].item.title }}
          </span>
                </ng-template>
            </td>
        </ng-container>

        <ng-container matColumnDef="title">
            <th mat-header-cell *matHeaderCellDef scope="col"> {{'BOOK.EDITION.TABLE.HEADERS.TITLE' | translate}}</th>
            <td mat-cell *matCellDef="let element; let index = index" [formGroup]="uiDatas[index].form">
                <mat-form-field appearance="outline" class="editable-field mff-space-1" subscriptSizing="dynamic">
                    <input matInput formControlName="title">
                </mat-form-field>
            </td>
        </ng-container>

        <ng-container matColumnDef="tome">
            <th mat-header-cell *matHeaderCellDef scope="col"> {{'BOOK.EDITION.TABLE.HEADERS.TOME' | translate}}</th>
            <td mat-cell *matCellDef="let element; let index = index" [formGroup]="uiDatas[index].form">
                <mat-form-field appearance="outline" class="editable-field mff-space-1" formGroupName="series"
                                subscriptSizing="dynamic">
                    <input type="number" matInput formControlName="tome">
                </mat-form-field>
            </td>
        </ng-container>

        <ng-container matColumnDef="possessionStatus">
            <th mat-header-cell *matHeaderCellDef
                scope="col"> {{'BOOK.EDITION.TABLE.HEADERS.POSSESSION_STATUS' | translate}}</th>
            <td mat-cell *matCellDef="let element; let index = index" [formGroup]="uiDatas[index].form">
                <mat-form-field appearance="outline" class="editable-field mff-space-1" subscriptSizing="dynamic">
                    <mat-select formControlName="possessionStatus">
                        <mat-option [value]="status"
                                    *ngFor="let status of possessionStatusValues">{{"BOOK.POSSESSION_STATE." + status | translate}}</mat-option>
                    </mat-select>
                </mat-form-field>
            </td>
        </ng-container>

        <ng-container matColumnDef="status">
            <th mat-header-cell *matHeaderCellDef scope="col"> {{'BOOK.EDITION.TABLE.HEADERS.STATUS' | translate}}</th>
            <td mat-cell *matCellDef="let element; let index = index" [formGroup]="uiDatas[index].form">
                <div class="justify-center-child-items">
                    <mat-button-toggle-group name="fontStyle" aria-label="Font Style" formControlName="status">
                        <mat-button-toggle [value]="status" [ngSwitch]="status" *ngFor="let status of statusValues">
                            <app-book-status-read-icon *ngSwitchCase="'READ'"></app-book-status-read-icon>
                            <app-book-status-unread-icon *ngSwitchCase="'UNREAD'"></app-book-status-unread-icon>
                            <app-book-status-reading-icon *ngSwitchCase="'READING'"></app-book-status-reading-icon>
                        </mat-button-toggle>
                    </mat-button-toggle-group>
                </div>
            </td>
        </ng-container>

        <ng-container matColumnDef="action">
            <th mat-header-cell *matHeaderCellDef scope="col"></th>
            <td mat-cell *matCellDef="let element; let index = index"
                [formGroup]="uiDatas[index].form">
                <div class="action-column-edition">
                    <div class="action-column-edition-buttons">
                        <button mat-button type="button" color="warn" [disabled]="!isRemovable(index)"
                                (click)="delete(index)">
                            <fa-icon [icon]="['fas', 'trash']"></fa-icon>
                        </button>
                        <button type="button" mat-button color="primary" (click)="goToEditPage(index)">
                            <fa-icon [icon]="['fas', 'pencil-alt']"></fa-icon>
                        </button>
                    </div>
                    <app-progressbar [start]="uiDatas[index].start" (finish)="onFinish(index)"></app-progressbar>
                </div>
            </td>
        </ng-container>

        <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
        <tr mat-row
            [ngClass]="{'edition-line': true, 'saved': (uiDatas[index].isSaved | async)}"
            *matRowDef="let row; columns: displayedColumns; let index = index">
        </tr>
    </table>
    <mat-paginator [pageSizeOptions]="pageSizes"
                   [pageIndex]="currentPage$ | async"
                   [length]="totalCount$ | async"
                   [pageSize]="pageSize$ | async"
                   (page)="onNewPage($event)">
    </mat-paginator>
</div>
